#include "config.h"
#include "trace.h"
#include "test/test_assert.h"
#include <stdio.h>

/** Given a run of days, length total_days, starting on
 * start_day_of_week, where 0=Sunday, 6=Saturday, return the number of
 * days that are a particular day, given by find_day_of_week
 */
int dayCount(int total_days, int start_day_of_week, int find_day_of_week)
{
    if (total_days == 0)
	return 0;
    
    int total_weeks = total_days / 7;
    int days_remaining = total_days % 7;

    // If I've got entire weeks, then I've got one find_day_of_week in
    // each.

    // The run of days remaining starts at start_day_of week and ends
    // at start_day_of_week + days_remaining - 1
    if ((((find_day_of_week + 7) - start_day_of_week) % 7) < days_remaining)
	return total_weeks + 1;
    
    return total_weeks;
}

int bittDayCount(int total_days, int start_day_of_week, int find_day_of_week)
{
    int d = total_days;
    int s = start_day_of_week;
    int t = find_day_of_week;
    
    int x = ( d / 7 ) + ( ( ( ( d % 7) - ( ( ( 7 - s ) + t ) % 7 ) ) % 7 ) + 1 );
    return x;
}

int slowDayCount(int total_days, int start_day_of_week, int find_day_of_week)
{
    int day_count = 0;
    for (int i = 0; i < total_days; ++i)
    {
	if (((start_day_of_week + i) % 7) == find_day_of_week)
	    ++day_count;
    }

    return day_count;
}

int main(void)
{
    for (int find_day_of_week = 0; find_day_of_week < 7; ++find_day_of_week)
    {
	for (int start_day_of_week = 0; start_day_of_week < 7; ++start_day_of_week)
	{
	    for (int total_days = 1; total_days < 650; ++total_days)
	    {
		TRACE("total_days = %d, start_day_of_week = %d, find_day_of_week = %d\n",
		      total_days, start_day_of_week, find_day_of_week);

		int roger = dayCount(total_days, start_day_of_week, find_day_of_week);
		int slow = slowDayCount(total_days, start_day_of_week, find_day_of_week);
		int bitt = bittDayCount(total_days, start_day_of_week, find_day_of_week);

		TRACE("roger = %d, slow = %d, bitt = %d\n", roger, slow, bitt);
		assertIntegersEqual(slow, roger);
	    }
	}
    }
    
    return assertSummarise();
}
